<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>Classwork</title>

    <script>
    /*
      Задание:
        1. Используя интерфейс который есть на страничке, написать визуальный
        конструктор обектов используя значение key-value, которые вводятся в
        соответствующие поля в форме.

        2. Каждый созданый обьект выводить в тег code после добавления каждого
        нового поля. Т.е мы должны визуально видить в каком состоянии наши обьекты
        сейчас

        3. По нажатию кнопки Combine Objects! два обьекта должны обьедениться
        используя метод Object.assing или spread operator и вывестись на стринчку.

        * Изменять HTML можно.

    */
   let obj1 = {};
   let obj2 = {};
   let objAssigned;
    
    document.addEventListener('DOMContentLoaded',()=>{
      document.forms.ObjForm1.addEventListener('submit',sendForm);
      document.forms.ObjForm2.addEventListener('submit',sendForm);

      function sendForm(e){
        e.preventDefault();
        let workObj = e.target.id === 'ObjForm1' ? obj1 : obj2
        workObj[e.target.key.value] = e.target.value.value;

        e.target.key.value = '';
        e.target.value.value = '';
        let result = e.target.parentElement.querySelector('.createdObj');
        render(workObj, result);
      }

      const result = document.getElementById('result');
      const resultBtn = document.getElementById('resultBtn');
      resultBtn.addEventListener('click', ()=>{
        render({...obj1,...obj2}, result);
      });

      function render(obj, target) {
        target.innerHTML = '';
        let code = document.createElement('code');
        let str = '';
        for (var key in obj) {
          str += `<br>${key}: '${obj[key]}'`
        }
        
        code.innerHTML = `{${str}<br>}`;
        target.appendChild(code);  
      }
    });
    </script>
</head>
<body>
  <div class="wrap">
      <div class="assigned">
        <form class="ObjForm" id="ObjForm1">
            <input name="key" placeholder="Enter your key"/>
            <input name="value" placeholder="Enter your value"/>
            <button type="submit">Send</button>
        </form>
        <div class="createResult">
          <header>
            Created Object
          </header>
          <div class="createdObj">
          </div>
        </div>
      </div>

      <div class="assigned">
        <form class="ObjForm" id="ObjForm2">
            <input name="key" placeholder="Enter your key"/>
            <input name="value" placeholder="Enter your value"/>
            <button type="submit">Send</button>
          </form>
          <div class="createResult">
            <header>
              Created Object
            </header>
            <div class="createdObj">
            </div>
          </div>
      </div>
    </div>
    <div class="resultBlock">
       <button id="resultBtn">Combine Objects!</button>
      <h3> Result: </h3>
      <div id="result"></div>
    </div>
      <style>
        .wrap{
          width: 800px;
          display: flex;
        }
        .ObjForm,
        .resultBlock{
          display: flex;
          flex-direction: column;
          align-items: flex-start;
          box-sizing: border-box;
          padding: 10px 20px;
        }

        .assigned{
          width: 300px;
          display: flex;
        }
        .createResult header{
          font-weight: 700;
        }
      </style>
</body>
</html>
